package analex;					// Fichier AnaLex.java
import java.io.*; import java.util.*; import symboles.*;
public class AnaLex {
    public static int ligne = 1;
    char peek = ' ';
    Hashtable mots = new Hashtable();
    void reserve(Mot w) { mots.put(w.lexeme, w); }
    public AnaLex() {
	reserve( new Mot( "if",    Cat.SI       ));
	reserve( new Mot( "else",  Cat.SINON    ));
	reserve( new Mot( "while", Cat.TANTQUE  ));
	reserve( new Mot( "do",    Cat.FAIRE    ));
	reserve( new Mot( "break", Cat.ROMPRE   ));
	reserve( Mot.Vrai  ); reserve( Mot.Faux      );
	reserve( Type.Bool ); reserve( Type.Entier   );
	reserve( Type.Car  ); reserve( Type.Flottant );
    }
    void lire_car() throws IOException { peek = (char)System.in.read(); }
    boolean lire_car(char c) throws IOException {
        lire_car();
        if( peek != c ) return false;
        peek = ' ';
        return true;
    }
    public UniLex parcourir() throws IOException {
	for( ; ; lire_car() ) {
	    if( peek == ' ' || peek == '\t' ) continue;
	    else if( peek == '\n' ) ligne = ligne + 1;
	    else break;
	}
	switch( peek ) {
	case '&':
	    if(lire_car('&')) return Mot.et;      else return new UniLex('&');
	case '|':
	    if(lire_car('|')) return Mot.ou;      else return new UniLex('|');
	case '=':
	    if(lire_car('=')) return Mot.egal;    else return new UniLex('=');
	case '!':
	    if(lire_car('=')) return Mot.nonegal; else return new UniLex('!');
	case '<':
	    if(lire_car('=')) return Mot.infegal; else return new UniLex('<');
	case '>':
	    if(lire_car('=')) return Mot.supegal; else return new UniLex('>');
	}
	if( Character.isDigit(peek) ) {
	    int v = 0;
	    do {
		v = 10*v + Character.digit(peek, 10); lire_car();
	    } while( Character.isDigit(peek) );
	    if( peek != '.' ) return new Nbre(v);
	    float x = v; float d = 10;
	    for(;;) {
		lire_car();
		if( ! Character.isDigit(peek) ) break;
		x = x + Character.digit(peek, 10) / d; d = d*10;
	    }
	    return new Reel(x);
	}
	if( Character.isLetter(peek) ) {
	    StringBuffer b = new StringBuffer();
	    do {
		b.append(peek); lire_car();
	    } while( Character.isLetterOrDigit(peek) );
	    String s = b.toString();
	    Mot w = (Mot)mots.get(s);
	    if( w != null ) return w;
	    w = new Mot(s, Cat.ID);
	    mots.put(s, w);
	    return w;
	}
        UniLex unl = new UniLex(peek); peek = ' ';
        return unl;
    }
}
